<?php
class SurveyActivity {

	var $survey_id;
	var $survey_key;
	var $survey_question_id;
	var $survey_priority;
	var $question_background_color;
	var $answer;
	var $WP_PLUGIN_URL;
	var $light_box;
	var $trigger_answer;
	var $answer_index;
	var $result_answer;
	var $question_type;
	
	var $question_display;
	
	var $action;
	var $script_reDirect;
	var $script_updateBtn;

	
	/**
	 * Survey Activity Constructor Function
	 *
	 * @return SurveyActivity
	 */
	function SurveyActivity() {
		$this->action = "";
		$this->survey_priority = 0;
		$this->survey_question_id = 0;		
	}
	
	
	/**
	 * Enter description here...
	 *
	 */
	function initSurveyActivity() {
	
	//added by Jack
if ( ! defined( 'WP_CONTENT_URL' ) )
	define( 'WP_CONTENT_URL', get_option( 'siteurl' ) . '/wp-content' );
if ( ! defined( 'WP_CONTENT_DIR' ) )
	define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
if ( ! defined( 'WP_PLUGIN_URL' ) )
	define( 'WP_PLUGIN_URL', WP_CONTENT_URL. '/plugins' );
if ( ! defined( 'WP_PLUGIN_DIR' ) )
	define( 'WP_PLUGIN_DIR', WP_CONTENT_DIR . '/plugins' );	

define('WP_PLUGIN_URL', plugins_url() );	
//
	//SSL fix

define( 'WP_PLUGIN_URL_SLLSAFE', str_replace(array('http://www.','https://www.', 'http://', 'https://', 'www.'),'//',plugins_url()) );


		$this->action = $_REQUEST['action'];
		
		switch ($this->action) {
			case 'LOAD_FUNNEL':
					$this->survey_key = $_POST['survey_key'];
					//$this->WP_PLUGIN_URL = $_POST['url'];
					$this->WP_PLUGIN_URL = WP_PLUGIN_URL_SLLSAFE;
					$this->light_box = $_POST['light_box'];
					$this->trigger_answer = $_POST['trigger_answer'];
					
					if ($this->loadFirstQuestion()) { 
						// Add an impression for a lightbox start
						if ($this->light_box == 'true') {
							$Survey = new Survey();
							$Survey->addImprint($this->survey_id);
						}
						
						if (!$this->loadNextQuestion()) {
							$this->question_display .= "|||eosf";
							
							// Set the completion cookie (if necessary)
							$this->setSFCookie();
						
							// Add a completion to the stats table
							$this->addCompletion();
						}
						
						echo $this->question_display;
					}
					
					exit;
					break;
			
			case 'SUBMIT_ANSWER':
					$this->survey_id = $_POST['survey_id'];
					$this->survey_question_id = $_POST['survey_question_id'];
					$this->survey_priority = $_POST['survey_priority'];
					$this->survey_key = $_POST['survey_key'];
					$this->question_background_color = $_POST['color'];
					$this->answer_index = $_POST['answer_index'];
					
					$this->answer = $_POST['answer'];
					//$this->WP_PLUGIN_URL = $_POST['url'];
					$this->WP_PLUGIN_URL = WP_PLUGIN_DIR;
						
					// Add the answer to the results table				
					$this->addAnswer();
					
					// Check to see if the specified answer has a rule
					$this->checkForAnswerRule();
					
					// Load the next question in the current column
					if (!$this->loadNextQuestion()) {
						$this->question_display .= "|||eosf";
						
						// Set the completion cookie (if necessary)
						$this->setSFCookie();
						
						// Add a completion to the stats table
						$this->addCompletion();
					}
					
					echo $this->question_display;
					
					exit;
					break;
					
	// BEGIN Added By Arvind On 7-AUG-2013  For Add UserInformation
	
		case 'SUBMIT_USERINFO':
					
						$this->survey_id = $_POST['survey_id'];
						$this->survey_question_id = $_POST['survey_question_id'];
					
						$this->survey_key = $_POST['survey_key'];
						$this->survey_priority = $_POST['survey_priority'];
						$this->question_background_color = $_POST['color'];
				
						
						$this->user_name = $_POST['user_name'];
						$this->email_id = $_POST['email_id'];
						$this->WP_PLUGIN_URL = WP_PLUGIN_DIR;
							
						// Add the answer to the results table
						$this->addAnswer1();
					
						// Check to see if the specified answer has a rule
						$this->checkForAnswerRule();
					
						// Load the next question in the current column
						if (!$this->loadNextQuestion()) {
							$this->question_display .= "|||eosf";
					
							// Set the completion cookie (if necessary)
							$this->setSFCookie();
					
							// Add a completion to the stats table
							$this->addCompletion();
						}
					
						echo $this->question_display;

						exit;
						break;
		
		case 'CANCELUSERINFO':
$this->survey_id = $_POST['survey_id'];
						$this->survey_question_id = $_POST['survey_question_id'];
					
						$this->survey_key = $_POST['survey_key'];
						$this->survey_priority = $_POST['survey_priority'];
						$this->question_background_color = $_POST['color'];
				   		$this->WP_PLUGIN_URL = WP_PLUGIN_DIR;
						// Check to see if the specified answer has a rule
						$this->checkForAnswerRule();
					
						// Load the next question in the current column
						if (!$this->loadNextQuestion()) {
							$this->question_display .= "|||eosf";
					
							// Set the completion cookie (if necessary)
							$this->setSFCookie();
					
							// Add a completion to the stats table
							$this->addCompletion();
						}
					
						echo $this->question_display;
			
			           exit;
					   break;
	// End By Arvind			

					
			default:	
					break;
		}
	}
	
	
	/**
	 * Add the answer to the results table
	 *
	 */
	private function addAnswer() {
		global $wpdb;
		$ActiveStatus = new ActiveStatus();
		//---------------------Begin -Added by Dinesh on 3rd September 2013----------
		// Insert the new users id while taking survey....
		$insanswer = $wpdb->get_row("SELECT priority FROM {$wpdb->prefix}sf_survey_questions WHERE survey_id = '$this->survey_id' and survey_question_id = '$this->survey_question_id'");
		if($insanswer->priority =='1')
		{
			$wpdb->insert($wpdb->prefix . 'sf_survey_user_information',
					array(
			
							'user_name' =>'',
							'email_id'=>''
					));
			
		}
		
		// ----------End by Dinesh on 3rd September, 2013----------------   
		$date = date("Y-m-d H:i:s");
		// BEGIN Added By Arvind On 7-AUG-2013  For Add UserInformation
		$r1 = $wpdb->get_row("SELECT user_id FROM {$wpdb->prefix}sf_survey_user_information WHERE 1 ORDER BY user_id DESC LIMIT 1");
		
		$wpdb->insert($wpdb->prefix . 'sf_survey_results', 
						array(
								'survey_id' => $this->survey_id,
								'survey_question_id' => $this->survey_question_id, 
								'answer' => $this->answer, 
								'active_status_id' => $ActiveStatus->active_records,
								'date_created' => $date,
								'user_id'=> $r1->user_id));			
		// End
	}

	
// BEGIN Added By Arvind On 7-AUG-2013  For Add UserInformation

	private function addAnswer1() {
	
		global $wpdb;
		$ActiveStatus = new ActiveStatus();
	
		$r1 = $wpdb->get_row("SELECT user_id FROM {$wpdb->prefix}sf_survey_user_information WHERE 1 ORDER BY user_id DESC LIMIT 1");
	
	
		$wpdb->update(
				($wpdb->prefix).'sf_survey_user_information',
				array(
						'user_name' =>$this->user_name,
						'email_id' => $this->email_id	),
				array( 'user_id' => $r1->user_id ));
	
	}
	// END
	
	/**
	 * Check to see if the specified answer/question has a column change
	 *
	 */
	private function checkForAnswerRule() {
		global $wpdb;
		$ActiveStatus = new ActiveStatus();

		$r = $wpdb->get_row("SELECT result_answer FROM {$wpdb->prefix}sf_survey_rules WHERE survey_question_id = '$this->survey_question_id' AND answer_index = '$this->answer_index'");
		
		if ($r->result_answer != '') {
			$this->result_answer = $r->result_answer;
		
		} else {
			$this->result_answer = 0;
		}
	}
	
	
	/**
	 * Enter description here...
	 *
	 */
	private function loadFirstQuestion() {
		if (func_num_args() > 0) {
			$this->survey_key = func_get_arg(0);
		}
		
		global $wpdb;
		$ActiveStatus = new ActiveStatus();
		
		// BEGIN Added By Arvind On 7-AUG-2013  For Add UserInformation
		
		/* $wpdb->insert($wpdb->prefix . 'sf_survey_user_information',
				array(
		
						'user_name' =>'',
						'email_id'=>''
				)); */
		
		//End
		
		$r = $wpdb->get_row("SELECT survey_id, question_background_color, answer_flows FROM {$wpdb->prefix}sf_surveys WHERE survey_key = '$this->survey_key' AND active_status_id = '$ActiveStatus->active_records'");
		
		if (!$r->survey_id) {
			return false;
		}

		if (!$r->answer_flows) {
			return false;
		}
		
		$this->survey_id = $r->survey_id;
		$this->question_background_color = $r->question_background_color;
		
		$tmpColumns = explode("|", $r->answer_flows);
		
		$this->result_answer = $tmpColumns[$this->trigger_answer];
		
		return true;
	}
	
	
	/**
	 * Load the next question in the current column
	 *
	 */
	private function loadNextQuestion() {
		global $wpdb;
		$ActiveStatus = new ActiveStatus();

		if ($this->result_answer > 0) {
			$r = $wpdb->get_row("SELECT * FROM {$wpdb->prefix}sf_survey_questions WHERE survey_id = '$this->survey_id' AND active_status_id = '$ActiveStatus->active_records' ORDER BY priority LIMIT " . ($this->result_answer - 1) . ",1");

		} else {
			$r = $wpdb->get_row("SELECT * FROM {$wpdb->prefix}sf_survey_questions WHERE survey_id = '$this->survey_id' AND survey_question_id <> '$this->survey_question_id' AND priority > $this->survey_priority AND active_status_id = '$ActiveStatus->active_records' ORDER BY priority LIMIT 1");
		}
		
		if (!$r->survey_question_id) {
			return false;
		}
				
		if ($r->question_type == 1) {
			$this->question_display =  "<div style=\"font-family: $r->font; font-size: $r->font_size; color: $r->font_color;\"><center>$r->question</center>";
		
			if ($r->answers) {			
				$answers = explode("|||", $r->answers);
				foreach ($answers as $answer_index => $tmpAnswer) {
					$jsAnswer = str_ireplace("'", "\'", $tmpAnswer);
					$this->question_display .= "<div class=\"sfQuestion\" style=\"background-color: $this->question_background_color; padding: 5px; margin-top: 5px; cursor: pointer; cursor: hand;\" onclick=\"jQuery(this).find('input').attr('checked', true); submitSFAnswer('$this->survey_key', '" . WP_PLUGIN_URL . "', $r->survey_id, $r->survey_question_id, $r->priority, '$jsAnswer', '$this->question_background_color', $answer_index);\"><input type=\"radio\"> $tmpAnswer</div>";
				}
			}
		
			$this->question_display .= "</div>";

		} elseif ($r->question_type == 2) {
			$this->question_display = $r->answers;			
		}
		
	// BEGIN Added By Arvind On 7-AUG-2013  For Add UserInformation
		
		elseif($r->question_type == 3){
		
			$this->question_display .="<div class=\"sfQuestion\" style=\"background-color: $this->question_background_color; padding: 5px; margin-top: 5px; cursor: pointer; cursor: hand;\"  id=\"usercontent\">
			<form action='' method='post' id=\"frm1\"> <h2> User Information </h2>
				
			<table  id=\"defaultcontent\">
			<tr>
			<td>User Name</td><td><input type=\"text\" name=\"uname\" id=\"uname\"></td>
			</tr>
			<tr>
			<td>Email Id</td><td><input type=\"text\" name=\"email\" id=\"email\"></td>
			</tr>
				
			</table></form>";
			$this->question_display .= "<button onclick=\"mysfUserinfo('$this->survey_key', '" . WP_PLUGIN_URL . "', $r->survey_id, $r->survey_question_id, $r->priority,'$this->question_background_color')\">Submit</button>  <button onclick=\"cancelUserInfo('$this->survey_key', '" . WP_PLUGIN_URL . "', $r->survey_id, $r->survey_question_id, $r->priority,'$this->question_background_color')\">Cancel</button> </div>";
		
		}
		
    //END
		if ($r->question_type != 1) {
			return false;
			
		} else {
			return true;
		}
	}
		
	
	/**
	 * Set the completion cookie (if necessary)
	 *
	 */
	private function setSFCookie() {
		global $wpdb;
		$r = $wpdb->get_row("SELECT survey_key, use_cookie, cookie_days FROM {$wpdb->prefix}sf_surveys WHERE survey_id = '$this->survey_id'");
			
		if ($r->use_cookie) {
			
		}
		
		setcookie($r->survey_key, 1, time() + 60 * 60 * 24 * $r->cookie_days, COOKIEPATH, COOKIE_DOMAIN, false);
	}
	
	
	/**
	 * Add a completion to the stats table
	 *
	 */
	private function addCompletion() {
                /* Begin - Arun 29-April-2013 */
		if($email = get_option('sf_email_id')){
		mail($email, 'Survey Answered','Your survey has been answered by a user at '.date('Y-m-d H:i:s').' on '.get_site_url(),'Notification@surveyfunnel.com');
	    }
/* Ended - Arun */
		global $wpdb;
		$ActiveStatus = new ActiveStatus();
		
		$date = date("Y-m-d H:i:s");
		
		$r = $wpdb->get_row("SELECT imprints, completions FROM {$wpdb->prefix}sf_survey_stats WHERE survey_id = '$this->survey_id'");

		if (!$r->imprints) {
			$wpdb->insert($wpdb->prefix . 'sf_survey_stats', 
							array(
									'survey_id' => $this->survey_id,
									'completions' => '1', 
									'active_status_id' => $ActiveStatus->active_records,
									'date_created' => $date));			
		} else {
			$tmpNum = $r->completions + 1;
			$wpdb->update($wpdb->prefix . 'sf_survey_stats', 
							array(
									'completions' => $tmpNum, 
									'date_modified' => $date
							), 
							array('survey_id' => $this->survey_id));			
		}
	}	
	
	
} // End Survey Activity Class
?>
