<h3>Survey Funnel Results: <?php echo $SurveyManage->survey_name; ?> - <a href="admin.php?page=survey_funnel_dashboard">Dashboard</a></h3>

<table width="99%" cellpadding="3" cellspacing="1">
<?php
global $wpdb;

$select = "SELECT {$wpdb->prefix}sf_survey_questions.survey_question_id, {$wpdb->prefix}sf_survey_questions.question, {$wpdb->prefix}sf_survey_questions.answers FROM {$wpdb->prefix}sf_survey_questions 
				WHERE {$wpdb->prefix}sf_survey_questions.survey_id = '$SurveyManage->survey_id' 
				AND {$wpdb->prefix}sf_survey_questions.active_status_id = 1 
				AND {$wpdb->prefix}sf_survey_questions.question_type = 1 
				ORDER BY {$wpdb->prefix}sf_survey_questions.priority";

//echo "$select\n<br>";
$tr = $wpdb->get_results($select);

$questions = array();
$answers = array();
$heights = array();

foreach ($tr as $r) {
	$heights[$r->survey_question_id] = count(explode("|||", $r->answers)) * 25;
	
	foreach (explode("|||", $r->answers) as $answer_name) {
		$answer_count = $wpdb->get_var($wpdb->prepare("SELECT COUNT(*) FROM {$wpdb->prefix}sf_survey_results WHERE survey_question_id = '$r->survey_question_id' AND answer = '$answer_name'"));
		$questions[$r->survey_question_id] = $r->question;
		$answers[$r->survey_question_id][$answer_name] = $answer_count;
	}	
}

if (count($questions)) {	
	foreach ($questions as $question_id => $question_name) {
		arsort($answers[$question_id]);
		
		$max_value = 0;
		$value_string = '';
		$legend_string = '';
		
		foreach ($answers[$question_id] as $answer_name => $answer_count) {
			if ($answer_count > $max_value) { $max_value = $answer_count; }
			$value_string .= "$answer_count,";
			$legend_string .= urlencode("$answer_name: $answer_count") . "|";
		}
		
		$value_string = substr($value_string, 0, strlen($value_string) - 1);
		$legend_string = substr($legend_string, 0, strlen($legend_string) - 1);

		if ($bg == "") {
			$bg = 'sfRow1';
		} else {
			$bg = '';
		}
		
		//<img src=\"http://chart.apis.google.com/chart?chxr=0,0,$max_value&chxt=x&chbh=a&chs=550x" . $heights[$question_id] . "&cht=bhs&chco=21759B,ECECEC,FF3100DF,FFD600DF&chds=0,$max_value,0,$max_value,0,$max_value&chd=t:$value_string&chdl=$legend_string\">
		
		echo "<tr>
				<td width=\"100%\" class=\"survey_funnel_stats_cell\">
					Question: <b>$question_name</b><br>";
		
					//echo "<img src=\"http://chart.apis.google.com/chart?chf=bg,s,EFEFEF&chs=300x150&cht=p3&chco=21759B&chds=0,$max_value&chd=t:$value_string&chdl=$legend_string\">";
					echo "<img src=\"http://chart.apis.google.com/chart?chs=300x150&cht=p3&chco=21759B&chds=0,$max_value&chd=t:$value_string&chdl=$legend_string\">";
					
		echo "</td>
		 	</tr><tr><td height=\"15\"></td></tr>";	
		
	}
}
?>
</table>